import ca.uhn.hl7v2.model.Message
import ca.uhn.hl7v2.model.v23.message.ORU_R01
import ca.uhn.hl7v2.parser.GenericParser
import ca.uhn.hl7v2.parser.Parser

/**
 * Created by IntelliJ IDEA.
 * User: davec
 * Date: 20-Feb-2008
 * Time: 2:46:41 PM
 * To change this template use File | Settings | File Templates.
 */
 def HL7Messages = new XmlParser().parse(new File('data/QA 20071101 v2.3.xml'))

    //println "The header is $HL7Messages"
    println  "There are ${HL7Messages.'@MessageCount'} messages "

    def messages = HL7Messages.Message
    messages.each {it ->

      println it.'@MsgID'
      Parser p = new GenericParser()
      String msg = it.value()[0]
      msg = msg.replace((char)'\n',(char)'\r')

      Message hapiMsg  = p.parse( msg )
      ORU_R01 oruR01 = (ORU_R01)hapiMsg

      println "Family Name ${oruR01.RESPONSE.PATIENT.PID.patientName.givenName} ${oruR01.RESPONSE.PATIENT.PID.patientName.familyName} "
			println "ORC Dump ${oruR01.RESPONSE.ORDER_OBSERVATION.ORC.dump()}"
      println "Placer Order Number ${oruR01.RESPONSE.ORDER_OBSERVATION.OBR.placerOrderNumber}"
		}